"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports[Symbol.toStringTag] = "Module";
var vue = require("vue");
var injectionJs = require("injection-js");
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
function __rest(s, e) {
  var t = {};
  for (var p in s)
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
      t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
      if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
        t[p[i]] = s[p[i]];
    }
  return t;
}
function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof2(obj2) {
      return typeof obj2;
    };
  } else {
    _typeof = function _typeof2(obj2) {
      return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
    };
  }
  return _typeof(obj);
}
function boundMethod(target, key, descriptor) {
  var fn = descriptor.value;
  if (typeof fn !== "function") {
    throw new TypeError("@boundMethod decorator can only be applied to methods not: ".concat(_typeof(fn)));
  }
  var definingProperty = false;
  return {
    configurable: true,
    get: function get() {
      if (definingProperty || this === target.prototype || this.hasOwnProperty(key) || typeof fn !== "function") {
        return fn;
      }
      var boundFn = fn.bind(this);
      definingProperty = true;
      Object.defineProperty(this, key, {
        configurable: true,
        get: function get2() {
          return boundFn;
        },
        set: function set(value) {
          fn = value;
          delete this[key];
        }
      });
      definingProperty = false;
      return boundFn;
    },
    set: function set(value) {
      fn = value;
    }
  };
}
function boundClass(target) {
  var keys;
  if (typeof Reflect !== "undefined" && typeof Reflect.ownKeys === "function") {
    keys = Reflect.ownKeys(target.prototype);
  } else {
    keys = Object.getOwnPropertyNames(target.prototype);
    if (typeof Object.getOwnPropertySymbols === "function") {
      keys = keys.concat(Object.getOwnPropertySymbols(target.prototype));
    }
  }
  keys.forEach(function(key) {
    if (key === "constructor") {
      return;
    }
    var descriptor = Object.getOwnPropertyDescriptor(target.prototype, key);
    if (typeof descriptor.value === "function") {
      Object.defineProperty(target.prototype, key, boundMethod(target, key, descriptor));
    }
  });
  return target;
}
function autobind() {
  if (arguments.length === 1) {
    return boundClass.apply(void 0, arguments);
  }
  return boundMethod.apply(void 0, arguments);
}
function Autobind() {
  return autobind;
}
function useProps() {
  const instance = vue.getCurrentInstance();
  return instance.props;
}
function useCtx() {
  const instance = vue.getCurrentInstance();
  return instance.setupContext;
}
function getCurrentApp() {
  var _a;
  return (_a = vue.getCurrentInstance()) === null || _a === void 0 ? void 0 : _a.appContext.app;
}
function getProtoMetadata(target, key, returnDesc = false) {
  if (!target)
    return [];
  const proto = Reflect.getPrototypeOf(target);
  if (!proto)
    return [];
  let res = Reflect.getMetadata(key, proto) || [];
  if (returnDesc) {
    res = res.map((k) => {
      if (typeof k === "string") {
        return {
          key: k,
          desc: getDeepOwnDescriptor(proto, k)
        };
      }
      if (typeof k === "object") {
        return {
          key: k,
          desc: getDeepOwnDescriptor(proto, k.key)
        };
      }
    });
  }
  return res;
}
function getDeepOwnDescriptor(proto, key) {
  if (!proto)
    return null;
  const desc = Reflect.getOwnPropertyDescriptor(proto, key);
  if (desc)
    return desc;
  return getDeepOwnDescriptor(Reflect.getPrototypeOf(proto), key);
}
function getEmitsFromProps(defaultProps) {
  const keys = Array.isArray(defaultProps) ? defaultProps : Object.keys(defaultProps);
  const emits = [];
  for (let key of keys) {
    if (!/^on/.test(key))
      continue;
    key = key.slice(2).replace(/Once$/, "");
    emits.push(key[0].toLowerCase() + key.slice(1));
  }
  return emits;
}
function injectService(service, defaultService) {
  return vue.inject(service.ProviderKey, defaultService);
}
const MetadataKey$4 = Symbol("Mut");
function Mut() {
  return function(target, key) {
    let list = Reflect.getMetadata(MetadataKey$4, target) || [];
    list = list.slice();
    const hasItem = list.find((k) => k === key);
    if (!hasItem)
      list.push(key);
    Reflect.defineMetadata(MetadataKey$4, list, target);
  };
}
function handler$3(targetThis) {
  const list = getProtoMetadata(targetThis, MetadataKey$4);
  if (!list || !list.length)
    return;
  for (const item of list) {
    const keyVal = vue.ref();
    Object.defineProperty(targetThis, item, {
      enumerable: true,
      configurable: true,
      get() {
        return keyVal.value;
      },
      set(v) {
        keyVal.value = v;
      }
    });
  }
}
const MutHandler = {
  key: "Mut",
  handler: handler$3
};
function Ref() {
  return Mut();
}
const MetadataKey$3 = Symbol("Computed");
function Computed() {
  return function(target, key) {
    let list = Reflect.getMetadata(MetadataKey$3, target) || [];
    list = list.slice();
    const hasItem = list.find((k) => k === key);
    if (!hasItem)
      list.push(key);
    Reflect.defineMetadata(MetadataKey$3, list, target);
  };
}
function handler$2(targetThis) {
  const list = getProtoMetadata(targetThis, MetadataKey$3, true);
  if (!list || !list.length)
    return;
  for (const item of list) {
    const desc = item.desc;
    const keyVal = vue.computed({
      get: () => {
        var _a;
        return (_a = desc.get) === null || _a === void 0 ? void 0 : _a.call(targetThis);
      },
      set: (v) => {
        var _a;
        return (_a = desc.set) === null || _a === void 0 ? void 0 : _a.call(targetThis, v);
      }
    });
    Object.defineProperty(targetThis, item.key, {
      enumerable: desc === null || desc === void 0 ? void 0 : desc.enumerable,
      configurable: true,
      get() {
        return keyVal.value;
      },
      set(v) {
        keyVal.value = v;
      }
    });
  }
}
const ComputedHandler = {
  key: "Computed",
  handler: handler$2
};
const MetadataKey$2 = Symbol("Hook");
function Hook(lifecycle) {
  return function(target, key) {
    let list = Reflect.getMetadata(MetadataKey$2, target) || [];
    list = list.slice();
    const hasItem = list.find((k) => k.key === key && k.lifecycle === lifecycle);
    if (!hasItem)
      list.push({ key, lifecycle });
    Reflect.defineMetadata(MetadataKey$2, list, target);
  };
}
function handler$1(targetThis) {
  const list = getProtoMetadata(targetThis, MetadataKey$2);
  if (!list || !list.length)
    return;
  for (const item of list) {
    let vueFn;
    switch (item.lifecycle) {
      case "BeforeMount":
        vueFn = vue.onBeforeMount;
        break;
      case "Mounted":
        vueFn = vue.onMounted;
        break;
      case "BeforeUpdate":
        vueFn = vue.onBeforeUpdate;
        break;
      case "Updated":
        vueFn = vue.onUpdated;
        break;
      case "BeforeUnmount":
        vueFn = vue.onBeforeUnmount;
        break;
      case "Unmounted":
        vueFn = vue.onUnmounted;
        break;
      case "Activated":
        vueFn = vue.onActivated;
        break;
      case "Deactivated":
        vueFn = vue.onDeactivated;
        break;
      case "ErrorCaptured":
        vueFn = vue.onErrorCaptured;
        break;
      case "RenderTracked":
        vueFn = vue.onRenderTracked;
        break;
      case "RenderTriggered":
        vueFn = vue.onRenderTriggered;
        break;
      case "ServerPrefetch":
        vueFn = vue.onServerPrefetch;
        break;
    }
    vueFn(() => targetThis[item.key]());
  }
}
const HookHandler = {
  key: "Hook",
  handler: handler$1
};
const MetadataKey$1 = Symbol("Link");
function Link() {
  return function(target, key) {
    let list = Reflect.getMetadata(MetadataKey$1, target) || [];
    list = list.slice();
    const hasItem = list.find((k) => k === key);
    if (!hasItem)
      list.push(key);
    Reflect.defineMetadata(MetadataKey$1, list, target);
  };
}
function handler(targetThis) {
  const list = getProtoMetadata(targetThis, MetadataKey$1);
  if (!list || !list.length)
    return;
  for (const item of list) {
    const instance = vue.getCurrentInstance();
    Object.defineProperty(targetThis, item, {
      enumerable: true,
      configurable: true,
      get() {
        return instance === null || instance === void 0 ? void 0 : instance.refs[item];
      }
    });
  }
}
const LinkHandler = {
  key: "Link",
  handler
};
const InjectorKey = Symbol("ReflectiveInjector");
const MetadataKey = Symbol("Component");
function Component(options) {
  return function(target) {
    Reflect.defineMetadata(MetadataKey, options, target);
    return injectionJs.Injectable()(target);
  };
}
function resolveComponent(target) {
  var _a, _b;
  if (!Reflect.getMetadata("annotations", target))
    return new target();
  const parent = vue.inject(InjectorKey, void 0);
  const options = Reflect.getOwnMetadata(MetadataKey, target);
  let deps = [target];
  if ((_a = options === null || options === void 0 ? void 0 : options.providers) === null || _a === void 0 ? void 0 : _a.length) {
    deps = deps.concat(options.providers);
  }
  if ((options === null || options === void 0 ? void 0 : options.autoResolveDeps) !== false) {
    deps = resolveDependencies(deps);
  }
  if ((_b = options === null || options === void 0 ? void 0 : options.exclude) === null || _b === void 0 ? void 0 : _b.length) {
    deps = deps.filter((k) => {
      var _a2;
      return !((_a2 = options.exclude) === null || _a2 === void 0 ? void 0 : _a2.includes(k));
    });
  }
  const resolveProviders = injectionJs.ReflectiveInjector.resolve(deps);
  const injector = injectionJs.ReflectiveInjector.fromResolvedProviders(resolveProviders, parent);
  if (options === null || options === void 0 ? void 0 : options.globalStore) {
    const current = vue.getCurrentInstance();
    const app = current.appContext.app;
    app.provide(InjectorKey, injector);
    app.getStore = () => injector;
    app.getService = (token) => injector.get(token);
  } else {
    vue.provide(InjectorKey, injector);
  }
  const compInstance = injector.get(target);
  resolveProviders.forEach((k) => injector.get(k.key.token));
  return compInstance;
}
function resolveDependencies(inputs) {
  const noConstructor = [];
  for (const input of inputs) {
    if (!(input instanceof Function) && !Array.isArray(input)) {
      noConstructor.push(input);
    }
  }
  const deps = new Set();
  function resolver(klass) {
    if (deps.has(klass) || noConstructor.find((k) => k !== klass && k.provide === klass))
      return;
    deps.add(klass);
    const resolves = injectionJs.ReflectiveInjector.resolve([klass]);
    for (const item of resolves) {
      for (const fact of item.resolvedFactories) {
        for (const dep of fact.dependencies) {
          if (dep.optional || dep.visibility instanceof injectionJs.SkipSelf || dep.key.token instanceof injectionJs.InjectionToken || typeof dep.key.token !== "function") {
            continue;
          }
          resolver(dep.key.token);
        }
      }
    }
  }
  for (const input of inputs)
    resolver(input);
  return Array.from(deps);
}
const GlobalStoreKey = "GlobalStoreKey";
class VueComponent {
  constructor() {
    this.props = useProps();
    this.context = useCtx();
    this.context.expose(this);
    const ThisConstructor = this.constructor;
    if (ThisConstructor.ProviderKey)
      vue.provide(ThisConstructor.ProviderKey, this);
    if (ThisConstructor.globalStore) {
      const current = vue.getCurrentInstance();
      const app = current.appContext.app;
      app.provide(GlobalStoreKey, this);
      app.getStore = () => this;
      app.getService = (token) => {
        if ((typeof token === "function" || typeof token === "object") && "ProviderKey" in token) {
          token = token.ProviderKey;
        }
        return current === null || current === void 0 ? void 0 : current.provides[token];
      };
    }
    VueComponent.handler.forEach((handler2) => handler2.handler(this));
  }
  static get __vccOpts() {
    if (this.__vccOpts__value)
      return this.__vccOpts__value;
    const CompConstructor = this;
    const { displayName, defaultProps, emits, ProviderKey: ProviderKey2, globalStore } = CompConstructor, left = __rest(CompConstructor, ["displayName", "defaultProps", "emits", "ProviderKey", "globalStore"]);
    return this.__vccOpts__value = Object.assign(Object.assign({}, left), {
      name: displayName || CompConstructor.name,
      props: defaultProps || {},
      emits: (emits || []).concat(getEmitsFromProps(CompConstructor.defaultProps || {})),
      setup: (props, ctx) => {
        const instance = VueComponent.resolveComponent(CompConstructor);
        return instance.render.bind(instance);
      }
    });
  }
  get $props() {
    return this.props;
  }
}
VueComponent.handler = [MutHandler, ComputedHandler, LinkHandler, HookHandler];
VueComponent.resolveComponent = resolveComponent;
const ProviderKey = "ProviderKey";
class VueService {
  constructor() {
    const ThisConstructor = this.constructor;
    if (ThisConstructor.ProviderKey)
      vue.provide(ThisConstructor.ProviderKey, this);
    VueService.handler.forEach((handler2) => handler2.handler(this));
  }
}
VueService.handler = [MutHandler, ComputedHandler, LinkHandler, HookHandler];
exports.Autobind = Autobind;
exports.Component = Component;
exports.Computed = Computed;
exports.GlobalStoreKey = GlobalStoreKey;
exports.Hook = Hook;
exports.InjectorKey = InjectorKey;
exports.Link = Link;
exports.Mut = Mut;
exports.ProviderKey = ProviderKey;
exports.Ref = Ref;
exports.VueComponent = VueComponent;
exports.VueService = VueService;
exports.getCurrentApp = getCurrentApp;
exports.getDeepOwnDescriptor = getDeepOwnDescriptor;
exports.getEmitsFromProps = getEmitsFromProps;
exports.getProtoMetadata = getProtoMetadata;
exports.injectService = injectService;
exports.useCtx = useCtx;
exports.useProps = useProps;
